/*

Copyright c) 2003-2004, AXE, Inc.  All rights reserved.

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef _OPVP_RPC_REQNO_H_
#define _OPVP_RPC_REQNO_H_

/* RPC request numbers */

/* special */
#define RPCNO_READY			1000
#define RPCNO_ECHO			1001

/* vector driver api */
#if (_PDAPI_VERSION_MAJOR_ == 0 && _PDAPI_VERSION_MINOR_ < 2)
#define RPCNO_OPENPRINTER		0
#define RPCNO_CLOSEPRINTER		1
#define RPCNO_STARTJOB			2
#define RPCNO_ENDJOB			3
#define RPCNO_STARTDOC			4
#define RPCNO_ENDDOC			5
#define RPCNO_STARTPAGE			6
#define RPCNO_ENDPAGE			7
#define RPCNO_RESETCTM			8
#define RPCNO_SETCTM			9
#define RPCNO_GETCTM			10
#define RPCNO_INITGS			11
#define RPCNO_SAVEGS			12
#define RPCNO_RESTOREGS			13
#define RPCNO_QUERYCOLORSPACE		14
#define RPCNO_SETCOLORSPACE		15
#define RPCNO_GETCOLORSPACE		16
#define RPCNO_QUERYROP			17
#define RPCNO_SETROP			18
#define RPCNO_GETROP			19
#define RPCNO_SETFILLMODE		20
#define RPCNO_GETFILLMODE		21
#define RPCNO_SETALPHACONSTANT		22
#define RPCNO_GETALPHACONSTANT		23
#define RPCNO_SETLINEWIDTH		24
#define RPCNO_GETLINEWIDTH		25
#define RPCNO_SETLINEDASH		26
#define RPCNO_GETLINEDASH		27
#define RPCNO_SETLINEDASHOFFSET		28
#define RPCNO_GETLINEDASHOFFSET		29
#define RPCNO_SETLINESTYLE		30
#define RPCNO_GETLINESTYLE		31
#define RPCNO_SETLINECAP		32
#define RPCNO_GETLINECAP		33
#define RPCNO_SETLINEJOIN		34
#define RPCNO_GETLINEJOIN		35
#define RPCNO_SETMITERLIMIT		36
#define RPCNO_GETMITERLIMIT		37
#define RPCNO_SETPAINTMODE		38
#define RPCNO_GETPAINTMODE		39
#define RPCNO_SETSTROKECOLOR		40
#define RPCNO_SETFILLCOLOR		41
#define RPCNO_SETBGCOLOR		42
#define RPCNO_NEWPATH			43
#define RPCNO_ENDPATH			44
#define RPCNO_STROKEPATH		45
#define RPCNO_FILLPATH			46
#define RPCNO_STROKEFILLPATH		47
#define RPCNO_SETCLIPPATH		48
#define RPCNO_SETCURRENTPOINT		49
#define RPCNO_LINEPATH			50
#define RPCNO_POLYGONPATH		51
#define RPCNO_RECTANGLEPATH		52
#define RPCNO_ROUNDRECTANGLEPATH	53
#define RPCNO_BEZIERPATH		54
#define RPCNO_ARCPATH			55
#define RPCNO_DRAWBITMAPTEXT		56
#define RPCNO_DRAWIMAGE			57
#define RPCNO_STARTDRAWIMAGE		58
#define RPCNO_TRANSFERDRAWIMAGE 	59
#define RPCNO_ENDDRAWIMAGE		60
#define RPCNO_STARTSCANLINE		61
#define RPCNO_SCANLINE			62
#define RPCNO_ENDSCANLINE		63
#define RPCNO_STARTRASTER		64
#define RPCNO_TRANSFERRASTERDATA	65
#define RPCNO_SKIPRASTER		66
#define RPCNO_ENDRASTER			67
#define RPCNO_STARTSTREAM		68
#define RPCNO_TRANSFERSTREAMDATA 	69
#define RPCNO_ENDSTREAM			70
#else
#define RPCNO_OPENPRINTER		0
#define RPCNO_CLOSEPRINTER		1
#define RPCNO_STARTJOB			2
#define RPCNO_ENDJOB			3
#define RPCNO_STARTDOC			4
#define RPCNO_ENDDOC			5
#define RPCNO_STARTPAGE			6
#define RPCNO_ENDPAGE			7
#define RPCNO_QUERYDEVICECAPABILITY	8
#define RPCNO_QUERYDEVICEINFO		9
#define RPCNO_RESETCTM			10
#define RPCNO_SETCTM			11
#define RPCNO_GETCTM			12
#define RPCNO_INITGS			13
#define RPCNO_SAVEGS			14
#define RPCNO_RESTOREGS			15
#define RPCNO_QUERYCOLORSPACE		16
#define RPCNO_SETCOLORSPACE		17
#define RPCNO_GETCOLORSPACE		18
#define RPCNO_QUERYROP			19
#define RPCNO_SETROP			20
#define RPCNO_GETROP			21
#define RPCNO_SETFILLMODE		22
#define RPCNO_GETFILLMODE		23
#define RPCNO_SETALPHACONSTANT		24
#define RPCNO_GETALPHACONSTANT		25
#define RPCNO_SETLINEWIDTH		26
#define RPCNO_GETLINEWIDTH		27
#define RPCNO_SETLINEDASH		28
#define RPCNO_GETLINEDASH		29
#define RPCNO_SETLINEDASHOFFSET		30
#define RPCNO_GETLINEDASHOFFSET		31
#define RPCNO_SETLINESTYLE		32
#define RPCNO_GETLINESTYLE		33
#define RPCNO_SETLINECAP		34
#define RPCNO_GETLINECAP		35
#define RPCNO_SETLINEJOIN		36
#define RPCNO_GETLINEJOIN		37
#define RPCNO_SETMITERLIMIT		38
#define RPCNO_GETMITERLIMIT		39
#define RPCNO_SETPAINTMODE		40
#define RPCNO_GETPAINTMODE		41
#define RPCNO_SETSTROKECOLOR		42
#define RPCNO_SETFILLCOLOR		43
#define RPCNO_SETBGCOLOR		44
#define RPCNO_NEWPATH			45
#define RPCNO_ENDPATH			46
#define RPCNO_STROKEPATH		47
#define RPCNO_FILLPATH			48
#define RPCNO_STROKEFILLPATH		49
#define RPCNO_SETCLIPPATH		50
#define RPCNO_RESETCLIPPATH		51
#define RPCNO_SETCURRENTPOINT		52
#define RPCNO_LINEPATH			53
#define RPCNO_POLYGONPATH		54
#define RPCNO_RECTANGLEPATH		55
#define RPCNO_ROUNDRECTANGLEPATH	56
#define RPCNO_BEZIERPATH		57
#define RPCNO_ARCPATH			58
#define RPCNO_DRAWBITMAPTEXT		59
#define RPCNO_DRAWIMAGE			60
#define RPCNO_STARTDRAWIMAGE		61
#define RPCNO_TRANSFERDRAWIMAGE 	62
#define RPCNO_ENDDRAWIMAGE		63
#define RPCNO_STARTSCANLINE		64
#define RPCNO_SCANLINE			65
#define RPCNO_ENDSCANLINE		66
#define RPCNO_STARTRASTER		67
#define RPCNO_TRANSFERRASTERDATA	68
#define RPCNO_SKIPRASTER		69
#define RPCNO_ENDRASTER			70
#define RPCNO_STARTSTREAM		71
#define RPCNO_TRANSFERSTREAMDATA 	72
#define RPCNO_ENDSTREAM			73
#endif

#endif	/* _OPVP_RPC_REQNO_H_ */
